.TH show_scig_arcs 1 "September 1995" "Scilab Group" "Scilab function"
.so ../sci.an
.SH NAME
show_scig_arcs - highlights a set of arcs
.SH CALLING SEQUENCE
.nf
show_scig_arcs(p,[sup])
.fi
.SH PARAMETERS
.TP 2
p
: row vector of arc numbers (directed graph) or edge numbers (undirected graph)
.TP 4
sup
: string, superposition flag
.SH DESCRIPTION
\fVshow_scig_arcs\fR highlights the set of arcs \fVp\fR of the
displayed graph in the current scilab window.
If the optional argument \fVsup\fR is equal to the string 'sup',
the highlighting is superposed on the previous one. 
.LP
The function can also be called to unhighlight highlighted arcs 
by using the call \fVshow_scig_arcs([])\fR. Note also 
that when a set of arcs is highlighted the automatic highlight 
during mouse move is not performed. Calling \fVshow_scig_arcs([])\fR 
restore the automatic highlight during mouse move.
.SH EXAMPLE
.nf
g=load_graph(SCI+'/demos/metanet/mesh100.graph');
t=min_weight_tree(1,g); 
show_scigraph(g,0,[500,500],[500,500]);
// hilite the tree t 
show_scig_arcs(t);
// unhilite 
show_scig_arcs([]);
.fi
.SH SEE ALSO
show_scig_nodes, show_scigraph

