.TH show_scigraph 1 "September 1995" "Scilab Group" "Scilab function"
.so ../sci.an
.SH NAME
show_scigraph - displays a graph
.SH CALLING SEQUENCE
.nf
nw = show_scigraph(g [,win,wdim,wpdim])
.fi
.SH PARAMETERS
.TP 2
g
: graph list
.TP 5
win
: scalar or string. If it is a number, it gives the graphic window
number to be used for graph drawing. If it is a string it can be 
\fV'new'\fR to create a new graphic window for graph drawing or 
\fV'rep'\fR if the current graphic window is to be used and the
previous graph is to be cleared. 
.TP 8
wdim=[w,h]
: graphic window internal dimensions (just as in \fVxset("wdim",w,h)\fR).
.TP 
wpdim=[w1,h1]
: graphic window external dimensions (just as in \fVxset("wpdim",w1,h1)\fR).
.SH DESCRIPTION
\fVshow_scigraph\fR displays the graph \fVg\fR in a specified (or in the
current)  graphic window. 
If there is no current graphic window, it is created.

.SH EXAMPLE
.nf
ta=[1 1 2 2 2 3 4 5 5 7 8 8 9 10 10 10 11 12 13 13 13 14 15 16 16 17 17];
he=[2 10 3 5 7 4 2 4 6 8 6 9 7 7 11 15 12 13 9 10 14 11 16 1 17 14 15];
g=make_graph('foo',1,17,ta,he);
g('node_x')=[283 163 63 57 164 164 273 271 339 384 504 513 439 623 631 757 642];
g('node_y')=[59 133 223 318 227 319 221 324 432 141 209 319 428 443 187 151 301];
show_scigraph(g,2);
show_scigraph(g,1,[500,500],[300,300])
.fi


